package jp.co.sds_corp.syslog.viewer.action;

import java.awt.Dimension;
import java.io.File;
import java.util.ResourceBundle;

import javax.swing.BoxLayout;
import javax.swing.border.TitledBorder;

import jp.co.sds_corp.syslog.action.IAction;
import jp.co.sds_corp.syslog.action.SoundAction;
import jp.co.sds_corp.util.window.FileSelector;
import jp.co.sds_corp.util.window.ValuePanel;

/**
* 音を鳴らす設定をするPanelです。
*/
public class SoundPanel extends AbstractPanel
{
	private static final long serialVersionUID = 1L;
	FileSelector	ap;
	ValuePanel		VAL1;
	ResourceBundle res;

	public SoundPanel() {
		res = ResourceBundle.getBundle( "resource.viewer" );
		String text;
		text = res.getString( "action.sound.title" );
		setBorder( new TitledBorder( text ));
		setLayout( new BoxLayout( this, BoxLayout.Y_AXIS ));

		createControls();
	}

	protected void createControls() {
		String text;
		text = res.getString( "action.sound.lbl1.text" );
		ap = new FileSelector( new File( "." ).getAbsolutePath(),
								text, FileSelector.Type.AUDIO );
		add( ap );
		text = res.getString( "action.sound.lbl2.text" );
		VAL1 = new ValuePanel( ValuePanel.ReturnType.INT, text );
		VAL1.setValueSize( new Dimension( 50, 22 ));
		add( VAL1 );
	}

	public void setEnabled( boolean bEn ) {
		ap.setEnabled( bEn );
		VAL1.setEnabled( bEn );
	}

	public void setAction( IAction action ) {
		super.setAction( action );
		if ( action == null ) {
			clear();
			return;
		}
		SoundAction sa = (SoundAction )action;
		ap.setSelection( sa.getFile() );
		VAL1.setValue( String.valueOf( sa.getTime() ));
	}

	public void clear() {
		ap.setSelection( null );
		VAL1.setValue( "1" );
	}

	public void updateAction() throws Exception {
		SoundAction sa = (SoundAction )action;
		String val = ap.getSelection();
		if ( val == null || val.length() == 0 ) {
			String msg = res.getString( "action.sound.err1.message" );
			throw( new Exception( msg ));
		}
		sa.setFile( val );
		if ( VAL1.getValue() != null ) {
			int time = ((Integer )VAL1.getValue()).intValue();
			if ( time < 0 ) {
				String msg = res.getString( "action.sound.err2.message" );
				throw( new Exception( msg ));
			}
			sa.setTime( time );
		}
	}

}

